************************************************************************
*	Exceptional cases of scalar functions labelled by EXT
*	Values in use: 301, 302, 303, 304, 305, 306, 307
*		       401, 402, 403, 404
************************************************************************
        function B0_ext(p,m0,m1,ext)
************************************************************************
*       scalar 2-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       18.11.98 Stefan Dittmaier
************************************************************************
	implicit real*8 (a-z)
        complex*16 B0_,B0_ext
        integer ext

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	if ( ((p.eq.mxe2).and.(m0.eq.mxe).and.(m1.eq.0d0)).or. 
     &	     ((p.eq.mxe2).and.(m0.eq.0d0).and.(m1.eq.mxe)) ) then
	  B0_ext = B0_(ml2(1),0d0,ml(1),0)
	  return
	endif

	if (p.eq.mxe2) then
	  xp  = 0d0
	else
	  xp  = p
	endif
	if (m0.eq.mxe) then
	  xm0 = 0d0
	else
	  xm0 = m0
	endif
	if (m1.eq.mxe) then
	  xm1 = 0d0
	else
	  xm1 = m1
	endif

	B0_ext = B0_(xp,xm0,xm1,0)

	end

************************************************************************
        function DB0_ext(p,m0,m1,ext)
************************************************************************
*       momentum derivative of scalar 2-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       18.11.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 DB0_,DB0_ext
        integer ext
 
        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	if ( ((p.eq.mxe2).and.(m0.eq.mxe).and.(m1.eq.0d0)).or. 
     &	     ((p.eq.mxe2).and.(m0.eq.0d0).and.(m1.eq.mxe)) ) then
	  DB0_ext = DB0_(ml2(1),0d0,ml(1),0)
	  return
	endif

	if (p.eq.mxe2) then
	  xp  = 0d0
	else
	  xp  = p
	endif
	if (m0.eq.mxe) then
	  xm0 = 0d0
	else
	  xm0 = m0
	endif
	if (m1.eq.mxe) then
	  xm1 = 0d0
	else
	  xm1 = m1
	endif

        DB0_ext = DB0_(xp,xm0,xm1,0)
 
        end

************************************************************************
        function B1_ext(p,m0,m1,ext)
************************************************************************
*       coefficient for vector 2-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       18.11.98 Stefan Dittmaier
************************************************************************
	implicit real*8 (a-z)
        complex*16 B1_,B1_ext
        integer ext

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	if ((p.eq.mxe2).and.(m0.eq.mxe).and.(m1.eq.0d0)) then
	  B1_ext = B1_(ml2(1),ml(1),0d0,0)
	  return
      	elseif ((p.eq.mxe2).and.(m0.eq.0d0).and.(m1.eq.mxe)) then
	  B1_ext = B1_(ml2(1),0d0,ml(1),0)
	  return
	endif

	if (p.eq.mxe2) then
	  xp  = 0d0
	else
	  xp  = p
	endif
	if (m0.eq.mxe) then
	  xm0 = 0d0
	else
	  xm0 = m0
	endif
	if (m1.eq.mxe) then
	  xm1 = 0d0
	else
	  xm1 = m1
	endif

	B1_ext = B1_(xp,xm0,xm1,0)

	end

************************************************************************
        function DB1_ext(p,m0,m1,ext)
************************************************************************
*       momentum derivative of coefficient for vector 2-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       18.11.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 DB1_,DB1_ext
        integer ext
 
        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	if ((p.eq.mxe2).and.(m0.eq.mxe).and.(m1.eq.0d0)) then
	  DB1_ext = DB1_(ml2(1),ml(1),0d0,0)
	  return
      	elseif ((p.eq.mxe2).and.(m0.eq.0d0).and.(m1.eq.mxe)) then
	  DB1_ext = DB1_(ml2(1),0d0,ml(1),0)
	  return
	endif

	if (p.eq.mxe2) then
	  xp  = 0d0
	else
	  xp  = p
	endif
	if (m0.eq.mxe) then
	  xm0 = 0d0
	else
	  xm0 = m0
	endif
	if (m1.eq.mxe) then
	  xm1 = 0d0
	else
	  xm1 = m1
	endif

        DB1_ext = DB1_(xp,xm0,xm1,0)
 
        end

************************************************************************
        function B20_ext(p,m0,m1,ext)
************************************************************************
*       tensor coefficient B00 for 2nd-rank tensor 2-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       18.11.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 B20_,B20_ext
        integer ext

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	if ((p.eq.mxe2).and.(m0.eq.mxe).and.(m1.eq.0d0)) then
	  B20_ext = B20_(ml2(1),ml(1),0d0,0)
	  return
      	elseif ((p.eq.mxe2).and.(m0.eq.0d0).and.(m1.eq.mxe)) then
	  B20_ext = B20_(ml2(1),0d0,ml(1),0)
	  return
	endif

	if (p.eq.mxe2) then
	  xp  = 0d0
	else
	  xp  = p
	endif
	if (m0.eq.mxe) then
	  xm0 = 0d0
	else
	  xm0 = m0
	endif
	if (m1.eq.mxe) then
	  xm1 = 0d0
	else
	  xm1 = m1
	endif

        B20_ext = B20_(xp,xm0,xm1,0)
 
        end
 
************************************************************************
        function B21_ext(p,m0,m1,ext)
************************************************************************
*       tensor coefficient B11 for 2nd-rank tensor 2-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       18.11.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 B21_,B21_ext
        integer ext

        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	if ((p.eq.mxe2).and.(m0.eq.mxe).and.(m1.eq.0d0)) then
	  B21_ext = B21_(ml2(1),ml(1),0d0,0)
	  return
      	elseif ((p.eq.mxe2).and.(m0.eq.0d0).and.(m1.eq.mxe)) then
	  B21_ext = B21_(ml2(1),0d0,ml(1),0)
	  return
	endif

	if (p.eq.mxe2) then
	  xp  = 0d0
	else
	  xp  = p
	endif
	if (m0.eq.mxe) then
	  xm0 = 0d0
	else
	  xm0 = m0
	endif
	if (m1.eq.mxe) then
	  xm1 = 0d0
	else
	  xm1 = m1
	endif

        B21_ext = B21_(xp,xm0,xm1,0)
 
        end
   
************************************************************************
        function C0_ext(q01,q12,q20,m0,m1,m2,ext)
************************************************************************
*       scalar 3-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       27.5.99 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 C0_,C0_ext,ieps,cspen
        integer ext

        COMMON/IR/LAMBDA,LAMBDA2
        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	ieps = dcmplx(0d0,1d-20)

	if (ext.eq.301) then
c***    --------------------
c***    C0(me^2,me^2,s,me,lambda,me)  with  me^2 << |s|
	  if ((q01.eq.mxe2).and.(q12.eq.mxe2).and.
     &	      (m0.eq.mxe).and.(m1.eq.0d0).and.(m2.eq.mxe)) then
	    s = q20
	    goto 301
	  endif
	  write(*,*) 'Inconsistent call of C0_ext(...,301) !'
	  stop
301	  continue
	  C0_ext = ( log(-s/lambda2-ieps)*log(-s/ml2(1)-ieps)
     &		     -log(-s/ml2(1)-ieps)**2/2d0 
     &		    -pi**2/6d0 )/s
	  return

	elseif (ext.eq.302) then
c***    ------------------------
c***	C0(k^2,me^2,t,MW,lambda,me)  with  me^2 << MW^2,|t|,|k^2|
	  if ((q12.eq.mxe2).and.
     &	      (m0.eq.MW).and.(m1.eq.0d0).and.(m2.eq.mxe)) then
    	    if (q01.eq.MW2) then
	      t = q20
	      goto 302
	    endif
c***	C0(me^2,t,k^2,lambda,me,MW)  with  me^2 << MW^2,|t|,|k^2|  
	  elseif ((q01.eq.mxe2).and.
     &	          (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.MW)) then
	    if (q20.eq.MW2) then
	      t = q12
	      goto 302
	    endif
c***	C0(me^2,k^2,t,me,lambda,MW)  with  me^2 << MW^2,|t|,|k^2|  
	  elseif ((q01.eq.mxe2).and.
     &	          (m0.eq.mxe).and.(m1.eq.0d0).and.(m2.eq.mw)) then
	    if (q12.eq.MW2) then
	      t = q20
	      goto 302
	    endif
c***	C0(t,me^2,k^2,MW,me,lambda)  with  me^2 << MW^2,|t|,|k^2|  
	  elseif ((q12.eq.mxe2).and.
     &	          (m0.eq.mw).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    if (q20.eq.MW2) then
	      t = q01
	      goto 302
	    endif
	  endif
	  write(*,*) 'Inconsistent call of C0_ext(...,302) !'
	  stop
302	  continue
	  C0_ext = ( log((MW2-t)/ml(1)/MW-ieps)
     &		      *log((MW2-t)*ml(1)/lambda2/MW-ieps)
     &		      +cspen(t/MW2+ieps) )/(t-MW2)
	  return

	elseif (ext.eq.303) then
c***    ------------------------
c***	C0(me^2,me^2,s, 0,me,MZ)  with  me^2 << MZ^2,|s|
	  if ((q01.eq.mxe2).and.(q12.eq.mxe2).and.
     &	      (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.MZ)) then
	    s = q20
	    goto 303
c***    C0(me^2,me^2,S,MZ,me, 0)  with  me^2 << |s|,MZ^2
	  elseif ((q01.eq.mxe2).and.(q12.eq.mxe2).and.
     &	          (m0.eq.MZ).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    s = q20
	    goto 303
	  endif
	  write(*,*) 'Inconsistent call of C0_ext(...,303) !'
	  stop
303	  continue
	  C0_ext = -( cspen(s/MZ2+ieps)
     &		     +log(ml2(1)/MZ2)*log(1d0-s/MZ2-ieps) )/s
	  return

	elseif (ext.eq.304) then
c***    ------------------------
c***	C0(me^2,me^2,s,0,me,0)  with  me^2 << |s|
	  if ((q01.eq.mxe2).and.(q12.eq.mxe2).and.
     &	      (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    s = q20
	    goto 304
	  endif
	  write(*,*) 'Inconsistent call of C0_ext(...,304) !'
	  stop
304	  continue
	  C0_ext = ( log(-s/ml2(1)-ieps)**2/2d0
     &		    +2d0*pi**2/3d0 )/s
	  return

	elseif (ext.eq.305) then
c***    ------------------------
c***	C0(me^2,t,MW^2,me,0,0)
	    if ((q01.eq.mxe2).and.(q20.eq.mw2).and.
     &	        (m0.eq.mxe).and.(m1.eq.0d0).and.(m2.eq.0d0)) then
	    t = q12
	    goto 305
c***	C0(MW^2,me^2,t,0,me,0)
	    elseif ((q01.eq.mw2).and.(q12.eq.mxe2).and.
     &	            (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    t = q20
	    goto 305
c***	C0(t,me^2,MW^2,t,0,0,me)
	  elseif ((q12.eq.mxe2).and.(q20.eq.mw2).and.
     &	          (m0.eq.0d0).and.(m1.eq.0d0).and.(m2.eq.mxe)) then
	    t = q01
	    goto 305
	  endif
	  write(*,*) 'Inconsistent call of C0_ext(...,305) !'
	  stop
305	  continue
	  C0_ext = ( log(t/mw2+ieps)**2/2d0-2d0*cspen(1d0-mw2/t+ieps)
     &		    -log(-t/ml2(1)-ieps)*log(t/mw2+ieps) )/(mw2-t)
	  return

	elseif (ext.eq.306) then
c***    ------------------------
c***	C0(m^2,k^2,0,m,0,MW)
c         if ((q01.eq.m0**2).and.(q12.eq.mw2).and.
          if ((abs(q01/m0**2-1d0).lt.1d-14).and.(q12.eq.mw2).and.
     &            (q20.eq.0d0).and.(m0.lt.10d0).and.
     &            (m1.eq.0d0).and.(m2.eq.MW)) then
	    m = m0
	    goto 306
	  endif
	  write(*,*) 'Inconsistent call of C0_ext(...,306) !'
	  stop
306	  continue
	  C0_ext = log(MW/m0)*log(lambda2/m0/MW)/MW2
	  return

	elseif (ext.eq.307) then
c***    ------------------------
c***	C0(m1^2,k^2,m2^2,0,m1,m2)   with  m1,m2 << |k^2|
	  if (m0.eq.0d0) then
	    k2 = q12
	    goto 307
	  endif
	  write(*,*) 'Inconsistent call of C0_ext(...,307) !'
          stop
307       continue
          C0_ext = ( log(-k2/m1/m2-ieps)*log(-k2/lambda2-ieps) 
     &		    -log(-k2/m1**2-ieps)**2/4d0 - pi**2/6d0
     &		    -log(-k2/m2**2-ieps)**2/4d0		)/k2
          return

C******* C0's from D01234 
C========================

	elseif (ext.eq.401) then
c***    ------------------------
	  if ((q01.eq.mw2).and.(q12.eq.mxe2).and.
     &	      (m0.eq.0d0).and.(m1.eq.mw).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,0d0,q20,m0,m1,m2,0)
	    return
	  elseif ((q20.eq.mw2).and.(q12.eq.mxe2).and.
     &	          (m0.eq.mxe).and.(m1.eq.mw).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,0d0,q20,0d0,m1,m2,0)
	    return
	  elseif ((q01.eq.mxe2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mxe).and.(m1.eq.0d0).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,305)
	    return
	  elseif ((q01.eq.mxe2).and.(q12.eq.mw2).and.
     &	          (m0.eq.mxe).and.(m1.eq.0d0).and.(m2.eq.mw)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,302)
	    return
	  elseif ((q01.eq.mw2).and.(q12.eq.mxe2).and.
     &	          (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,305)
	    return
	  elseif ((q12.eq.mxe2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,302)
	    return
	  elseif ((q01.eq.mxe2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.0d0).and.(m2.eq.0d0)) then
	    C0_ext = C0_(0d0,q12,q20,m0,m1,m2,0)
	    return
	  elseif ((q01.eq.mxe2).and.(q12.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.0d0).and.(m2.eq.mxe)) then
	    C0_ext = C0_(0d0,q12,q20,m0,m1,0d0,0)
	    return
	  else
	    write(*,*) 'Inconsistent call of C0_ext(...,401) !'
	    stop
	  endif

	elseif (ext.eq.402) then
c***    ------------------------
	  if ((q01.eq.mxe2).and.(q12.eq.mxe2).and.
     &	      (m0.eq.mxe).and.(m1.eq.0d0).and.(m2.eq.mxe)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,301)
	    return
	  elseif ((q12.eq.mxe2).and.(q20.eq.mw2).and.
     &	          (m0.eq.0d0).and.(m1.eq.0d0).and.(m2.eq.mxe)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,305)
	    return
	  elseif ((q01.eq.mw2).and.(q20.eq.mw2).and.
     &	          (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.mxe)) then
	    C0_ext = C0_(q01,q12,q20,m0,0d0,0d0,0)
	    return
	  elseif ((q01.eq.mw2).and.(q12.eq.mxe2).and.
     &	          (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,305)
	    return
	  else
	    write(*,*) 'Inconsistent call of C0_ext(...,402) !'
	    stop
	  endif

	elseif (ext.eq.403) then
c***    ------------------------
	  if ((q01.eq.mxe2).and.(q12.eq.mxe2).and.
     &	      (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,304)
	    return
	  elseif ((q12.eq.mxe2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,302)
	    return
	  elseif ((q01.eq.mw2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.0d0).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,0)
	    return
	  elseif ((q01.eq.mw2).and.(q12.eq.mxe2).and.
     &	          (m0.eq.mw).and.(m1.eq.0d0).and.(m2.eq.mxe)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,302)
	    return
	  else
	    write(*,*) 'Inconsistent call of C0_ext(...,403) !'
	    stop
	  endif

	elseif (ext.eq.404) then
c***    ------------------------
	  if ((q01.eq.mxe2).and.(q12.eq.mxe2).and.
     &	      (m0.eq.0d0).and.(m1.eq.mxe).and.(m2.eq.mz)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,303)
	    return
	  elseif ((q12.eq.mxe2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.mxe).and.(m2.eq.mz)) then
	    C0_ext = C0_(q01,0d0,q20,m0,0d0,m2,0)
	    return
	  elseif ((q01.eq.mw2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.0d0).and.(m2.eq.mz)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,0)
	    return
	  elseif ((q01.eq.mw2).and.(q12.eq.mxe2).and.
     &	          (m0.eq.mw).and.(m1.eq.0d0).and.(m2.eq.mxe)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,302)
	    return
	  elseif ((q01.eq.mxe2).and.(q12.eq.mxe2).and.
     &	          (m0.eq.mz).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,303)
	    return
	  elseif ((q12.eq.mxe2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.mxe).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,302)
	    return
	  elseif ((q01.eq.mw2).and.(q20.eq.mw2).and.
     &	          (m0.eq.mw).and.(m1.eq.mz).and.(m2.eq.0d0)) then
	    C0_ext = C0_(q01,q12,q20,m0,m1,m2,0)
	    return
	  elseif ((q01.eq.mw2).and.(q12.eq.mxe2).and.
     &	          (m0.eq.mw).and.(m1.eq.mz).and.(m2.eq.mxe)) then
	    C0_ext = C0_(q01,0d0,q20,m0,m1,0d0,0)
	    return
	  else
	    write(*,*) 'Inconsistent call of C0_ext(...,404) !'
	    stop
	  endif

	endif

	C0_ext = C0_(q01,q12,q20,m0,m1,m2,0)

	end
   
************************************************************************
        function D0_ext(P1,P2,P3,P4,P12,P23,M1,M2,M3,M4,ext)
************************************************************************
*       scalar 4-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       18.11.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 D0_,D0_ext,ieps,z1,z2,cspen
        integer ext

        COMMON/IR/LAMBDA,LAMBDA2
        common/param/pi,el,alpha,alpha0,alphaz,alphas,GF,cw,cw2,sw,sw2,
     &               mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &               mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)

	ieps = dcmplx(0d0,1d-20)

	if (ext.eq.401) then
c***    --------------------
c***	D0(me^2,kp^2,me^2,km^2,u,t,me,0,MW,0)  with me -> 0
	  if ((p1.eq.mxe2).and.(p3.eq.mxe2).and.(m1.eq.mxe).and.
     &	      (m2.eq.0d0).and.(m3.eq.MW).and.(m4.eq.0d0)) then
    	    if ((p2.eq.MW2).and.(p4.eq.MW2)) then
	      u = p12
	      t = p23
	      goto 401
	    endif
	  endif
c***	D0(me^2,kp^2,me^2,km^2,u,t,MW,0,me,0)  with me -> 0
	  if ((p1.eq.mxe2).and.(p3.eq.mxe2).and.(m1.eq.MW).and.
     &	      (m2.eq.0d0).and.(m3.eq.mxe).and.(m4.eq.0d0)) then
    	    if ((p2.eq.MW2).and.(p4.eq.MW2)) then
	      u = p12
	      t = p23
	      goto 401
	    endif
	  endif
	  write(*,*) 'Inconsistent call of D0_ext(...,401) !'
	  stop
401	  continue
	  D0_ext = (-log(ml(1)/mw)**2
     &		    +log((mw2-u)/mw/ml(1)-ieps)*log(mw2/lambda2)
     &	            +log((mw2-u)/mw2-ieps)**2
     &	            +2d0*log((mw2-u)/ml(1)/mw-ieps)*log(t/mw2+ieps)
     &		    +cspen(1d0-(u-mw2)/mw2-ieps) )/t/(u-mw2)
	  return

	elseif (ext.eq.402) then
c***    --------------------
c***	D0(kp^2,me^2,me^2,km^2,t,s,0,me,0,me)  with me -> 0
	  if ((p2.eq.mxe2).and.(p3.eq.mxe2).and.(m1.eq.0d0).and.
     &	      (m2.eq.mxe).and.(m3.eq.0d0).and.(m4.eq.mxe)) then
    	    if ((p1.eq.MW2).and.(p4.eq.MW2)) then
	      t = p12
	      s = p23
	      goto 402
	    endif
	  endif
	  write(*,*) 'Inconsistent call of D0_ext(...,402) !'
	  stop
402	  continue
	  D0_ext = ( -log(-s/ml2(1)-ieps)**2/2d0
     &		     +log(-s/ml2(1)-ieps)*( 
     &		        +log(-s/lambda2-ieps)
     &			+2d0*log(t/mw2+ieps) )
     &		    -pi**2/6d0 )/s/t
	  return

	elseif (ext.eq.403) then
c***    --------------------
c***	D0(kp^2,me^2,me^2,km^2,t,s,MW,0,me,0)  with me -> 0
	  if ((p2.eq.mxe2).and.(p3.eq.mxe2).and.(m1.eq.MW).and.
     &	      (m2.eq.0d0).and.(m3.eq.mxe).and.(m4.eq.0d0)) then
    	    if ((p1.eq.MW2).and.(p4.eq.MW2)) then
	      t = p12
	      s = p23
	      goto 403
	    endif
	  endif
	  write(*,*) 'Inconsistent call of D0_ext(...,402) !'
	  stop
403	  continue
	  D0_ext = 2d0*log((mw2-t)/ml(1)/mw-ieps)
     &		   *log(-s/lambda2-ieps)/s/(t-mw2)
	  return

	elseif (ext.eq.404) then
c***    --------------------
c***	D0(kp^2,me^2,me^2,km^2,t,s,MW,0,me,MZ)  with me -> 0
	  if ((p2.eq.mxe2).and.(p3.eq.mxe2).and.(m1.eq.MW).and.
     &	      (m2.eq.0d0).and.(m3.eq.mxe).and.(m4.eq.MZ)) then
    	    if ((p1.eq.MW2).and.(p4.eq.MW2).and.(p12.lt.0d0)) then
	      t = p12
	      s = p23
	      goto 404
	    endif
c***	D0(kp^2,me^2,me^2,km^2,t,s,MW,MZ,me,0)  with me -> 0
	  elseif ((p2.eq.mxe2).and.(p3.eq.mxe2).and.(m1.eq.MW).and.
     &	          (m2.eq.MZ).and.(m3.eq.mxe).and.(m4.eq.0d0)) then
    	    if ((p1.eq.MW2).and.(p4.eq.MW2).and.(p12.lt.0d0)) then
	      t = p12
	      s = p23
	      goto 404
	    endif
	  endif
	  write(*,*) 'Inconsistent call of D0_ext(...,404) !'
	  stop
404	  continue
	  z1     = dcmplx(1d0,+sqrt(4d0*mw2/mz2-1d0))/2d0
	  z2     = dcmplx(1d0,-sqrt(4d0*mw2/mz2-1d0))/2d0
	  D0_ext = (-log((mw2-t)/ml(1)/mw-ieps)**2
     &		    +log((mw2-t)/ml(1)/mw-ieps)
     &		     *( log(lambda2/ml2(1))-2d0*log(1d0-s/mz2-ieps) )
     &		    -cspen(1d0-(mw2-t)/mw2*z1)+pi**2/6d0
     &		    -cspen(1d0-(mw2-t)/mw2*z2)	    )/(t-mw2)/(mz2-s)
	  return

	endif

	D0_ext = D0_(P1,P2,P3,P4,P12,P23,M1,M2,M3,M4,0)

	end
   
************************************************************************
        function E0_ext(p1,p2,p3,p4,p5,s12,s23,s34,s45,s15,
     &                  m0,m1,m2,m3,m4,ext)
************************************************************************
*       scalar 5-point function
*-----------------------------------------------------------------------
*	special cases specified by "ext" 
*	default = general result (ext=0)
*-----------------------------------------------------------------------
*       18.11.98 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 E0_,E0_ext
        integer ext

	E0_ext = E0_(p1,p2,p3,p4,p5,s12,s23,s34,s45,s15,
     &               m0,m1,m2,m3,m4,0)

	end
