      subroutine setup_graphs(smc,rs)
      integer i,ebin,smc
      integer dsdc,dsdcg
      integer hmax,bmax
      parameter(hmax=1000)
      parameter(bmax=2000)
      integer parts(hmax)
      real*8 elim,rs
      real*8 deltas,deltac,deltags,deltagc,loglow,logup
      real*8 mini(hmax),maxi(hmax),stepi(hmax)

      common/pawc/hmemor(10000000)
      common/par_dsdc/loglow,logup
      common/tcuts/deltas,deltac,deltags,deltagc
      common/choice/dsdc,dsdcg
      common/hloc/parts,mini,maxi,stepi

      call hlimit(10000000)
c initialization
      do i=1,hmax
         stepi(i)=1d0
         parts(i)=1
         mini(i)=0d0
         maxi(i)=0d0
      end do
      if (smc.ne.2.and.(dsdc.ne.0.or.dsdcg.ne.0)) then
         do i=1,3 
            mini(100+i)=loglow
            maxi(100+i)=logup
            parts(100+i)=100
         end do
      end if

c total cross section
      mini(1)=-0.5d0
      maxi(1)=0.5d0
      parts(1)=1
      ebin=50
      elim=rs/2d0
c invariant mass distributions
      mini(2)=75d0
      maxi(2)=85d0
      parts(2)=ebin
      mini(3)=75d0
      maxi(3)=85d0
      parts(3)=ebin
c production and scattering angle distributions
      do i=4,9
         mini(i)=-1d0
         maxi(i)=1d0
         parts(i)=ebin
      end do
c photon-energy distributions
      mini(10)=0d0
      maxi(10)=50d0
      parts(10)=ebin
c photon-production angle
      mini(11)=-1d0
      maxi(11)=1d0
      parts(11)=ebin
c minimal angle between photon and charged final-state particles
      mini(12)=0d0
      maxi(12)=180d0
      parts(12)=ebin
c energy distributions:
      do i=13,16
         mini(i)=0d0
         maxi(i)=elim
         parts(i)=ebin
      end do
c decay angle in cmf of w boson
      do i=17,20
         mini(i)=-1d0
         maxi(i)=1d0
         parts(i)=ebin
      end do
c angle between the decay planes
      do i=21,23
         mini(i)=0d0
         maxi(i)=360d0
         parts(i)=ebin
      end do
c angle between the fermions corresponding to one W boson
      do i=24,25
         mini(i)=-1d0
         maxi(i)=1d0
         parts(i)=ebin
      end do
c Born distributions:     
      do i=1,25
         parts(200+i)=parts(i)
         mini(200+i)=mini(i)
         maxi(200+i)=maxi(i)
c 2->4 alone:
         parts(400+i)=parts(i)
         mini(400+i)=mini(i)
         maxi(400+i)=maxi(i)
c 2->5 alone:
         parts(500+i)=parts(i)
         mini(500+i)=mini(i)
         maxi(500+i)=maxi(i)
      end do

      do i=1,hmax
         if(parts(i).ne.0)
     $        stepi(i)=(maxi(i)-mini(i))/parts(i)
         if(stepi(i).eq.0d0)stepi(i)=1d0
      end do

      if (smc.ne.2) then
         if (dsdc.eq.1.or.dsdcg.eq.1)then
            call hbook1(101,' log10(deltas) $',parts(101),
     $           real(mini(101)),real(maxi(101)),0)
            call hbook1(102,' log10(deltas) (2->4) $',
     $           parts(102),real(mini(102)),real(maxi(102)),0)
            call hbook1(103,' log10(deltas) (2->5) $',
     $           parts(103),real(mini(103)),real(maxi(103)),0)
         else if(dsdc.eq.2.or.dsdcg.eq.2) then   
            call hbook1(101,' log10(deltac) $',parts(101),
     $           real(mini(101)),real(maxi(101)),0)
            call hbook1(102,' log10(deltac) (2->4) $',
     $           parts(102),real(mini(102)),
     $           real(maxi(102)),0)
            call hbook1(103,' log10(deltac) (2->5) $',
     $        parts(103),real(mini(103)),real(maxi(103)),0)
         end if
      end if

      call hbook1(1,' tot. sigma ',parts(1),
     $     real(mini(1)),real(maxi(1)),0)
      call hbook1(2,' M(W+) ',parts(2),
     $     real(mini(2)),real(maxi(2)),0)
      call hbook1(3,' M(W-) ',parts(3),
     $     real(mini(3)),real(maxi(3)),0)
c production angles:
      call hbook1(4,' cos(theta(W+)) ',parts(4),
     $     real(mini(4)),real(maxi(4)),0)
      call hbook1(5,' cos(theta(W-)) ',parts(5),
     $     real(mini(5)),real(maxi(5)),0)
c scattering angles:
      call hbook1(6,' cos(theta(W+,f1)) ',parts(6),
     $     real(mini(6)),real(maxi(6)),0)
      call hbook1(7,' cos(theta(W+,f2)) ',parts(7),
     $     real(mini(7)),real(maxi(7)),0)
      call hbook1(8,' cos(theta(W-,f3)) ',parts(8),
     $     real(mini(8)),real(maxi(8)),0)
      call hbook1(9,' cos(theta(W-,f4)) ',parts(9),
     $     real(mini(9)),real(maxi(9)),0)
      call hbook1(10,' E photon$',parts(10),
     $     real(mini(10)),real(maxi(10)),0)
      call hbook1(11,' cos(photon)$',parts(11),
     $     real(mini(11)),real(maxi(11)),0)
      call hbook1(12,' theta(photon-f)$',parts(12),
     $     real(mini(12)),real(maxi(12)),0)
      call hbook1(13,' E fermion1$',parts(13),
     $     real(mini(13)),real(maxi(13)),0)
      call hbook1(14,' E fermion2$',parts(14),
     $     real(mini(14)),real(maxi(14)),0)
      call hbook1(15,' E fermion3$',parts(15),
     $     real(mini(15)),real(maxi(15)),0)
      call hbook1(16,' E fermion4$',parts(16),
     $     real(mini(16)),real(maxi(16)),0)
c scattering angles in W CMS:
      call hbook1(17,' cos(theta(W+,f1*)) ',parts(17),
     $     real(mini(17)),real(maxi(17)),0)
      call hbook1(18,' cos(theta(W+,f2*)) ',parts(18),
     $     real(mini(18)),real(maxi(18)),0)
      call hbook1(19,' cos(theta(W-,f3*)) ',parts(19),
     $     real(mini(19)),real(maxi(19)),0)
      call hbook1(20,' cos(theta(W-,f4*)) ',parts(20),
     $     real(mini(20)),real(maxi(20)),0)
c Azimuthal angles:
      call hbook1(21,' Phi ',parts(21),
     $     real(mini(21)),real(maxi(21)),0)
      call hbook1(22,' phi(W+) ',parts(22),
     $     real(mini(22)),real(maxi(22)),0)
      call hbook1(23,' phi(W-) ',parts(23),
     $     real(mini(23)),real(maxi(23)),0)
c
      call hbook1(24,' cos(theta(f1,f2)) ',parts(24),
     $     real(mini(24)),real(maxi(24)),0)
      call hbook1(25,' cos(theta(f3,f4)) ',parts(25),
     $     real(mini(25)),real(maxi(25)),0)
c
c LO plots
c
      call hbook1(201,' tot. sigma ',parts(201),
     $     real(mini(201)),real(maxi(201)),0)
      call hbook1(202,' M(W+) ',parts(202),
     $     real(mini(202)),real(maxi(202)),0)
      call hbook1(203,' M(W-) ',parts(203),
     $     real(mini(203)),real(maxi(203)),0)
c production angles:
      call hbook1(204,' cos(theta(W+)) ',parts(204),
     $     real(mini(204)),real(maxi(204)),0)
      call hbook1(205,' cos(theta(W-)) ',parts(205),
     $     real(mini(205)),real(maxi(205)),0)
c scattering angles:
      call hbook1(206,' cos(theta(W+,f1)) ',parts(206),
     $     real(mini(206)),real(maxi(206)),0)
      call hbook1(207,' cos(theta(W+,f2)) ',parts(207),
     $     real(mini(207)),real(maxi(207)),0)
      call hbook1(208,' cos(theta(W-,f3)) ',parts(208),
     $     real(mini(208)),real(maxi(208)),0)
      call hbook1(209,' cos(theta(W-,f4)) ',parts(209),
     $     real(mini(209)),real(maxi(209)),0)
c
      call hbook1(213,' E fermion1$',parts(213),
     $     real(mini(213)),real(maxi(213)),0)
      call hbook1(214,' E fermion2$',parts(214),
     $     real(mini(214)),real(maxi(214)),0)
      call hbook1(215,' E fermion3$',parts(215),
     $     real(mini(215)),real(maxi(215)),0)
      call hbook1(216,' E fermion4$',parts(216),
     $     real(mini(216)),real(maxi(216)),0)
c scattering angles in W CMS:
      call hbook1(217,' cos(theta(W+,f1*)) ',parts(217),
     $     real(mini(217)),real(maxi(217)),0)
      call hbook1(218,' cos(theta(W+,f2*)) ',parts(218),
     $     real(mini(218)),real(maxi(218)),0)
      call hbook1(219,' cos(theta(W-,f3*)) ',parts(219),
     $     real(mini(219)),real(maxi(219)),0)
      call hbook1(220,' cos(theta(W-,f4*)) ',parts(220),
     $     real(mini(220)),real(maxi(220)),0)
c Azimuthal angles:
      call hbook1(221,' Phi ',parts(221),
     $     real(mini(221)),real(maxi(221)),0)
      call hbook1(222,' phi(W+) ',parts(222),
     $     real(mini(222)),real(maxi(222)),0)
      call hbook1(223,' phi(W-) ',parts(223),
     $     real(mini(223)),real(maxi(223)),0)
c
      call hbook1(224,' cos(theta(f1,f2)) ',parts(224),
     $     real(mini(224)),real(maxi(224)),0)
      call hbook1(225,' cos(theta(f3,f4)) ',parts(225),
     $     real(mini(225)),real(maxi(225)),0)
c
c 2->4 plots:
c
      call hbook1(401,' tot. sigma ',parts(401),
     $     real(mini(401)),real(maxi(401)),0)
      call hbook1(402,' M(W+) ',parts(402),
     $     real(mini(402)),real(maxi(402)),0)
      call hbook1(403,' M(W-) ',parts(403),
     $     real(mini(403)),real(maxi(403)),0)
c production angles:
      call hbook1(404,' cos(theta(W+)) ',parts(404),
     $     real(mini(404)),real(maxi(404)),0)
      call hbook1(405,' cos(theta(W-)) ',parts(405),
     $     real(mini(405)),real(maxi(405)),0)
c scattering angles:
      call hbook1(406,' cos(theta(W+,f1)) ',parts(406),
     $     real(mini(406)),real(maxi(406)),0)
      call hbook1(407,' cos(theta(W+,f2)) ',parts(407),
     $     real(mini(407)),real(maxi(407)),0)
      call hbook1(408,' cos(theta(W-,f3)) ',parts(408),
     $     real(mini(408)),real(maxi(408)),0)
      call hbook1(409,' cos(theta(W-,f4)) ',parts(409),
     $     real(mini(409)),real(maxi(409)),0)
c
      call hbook1(413,' E fermion1$',parts(413),
     $     real(mini(413)),real(maxi(413)),0)
      call hbook1(414,' E fermion2$',parts(414),
     $     real(mini(414)),real(maxi(414)),0)
      call hbook1(415,' E fermion3$',parts(415),
     $     real(mini(415)),real(maxi(415)),0)
      call hbook1(416,' E fermion4$',parts(416),
     $     real(mini(416)),real(maxi(416)),0)
c scattering angles in W CMS:
      call hbook1(417,' cos(theta(W+,f1*)) ',parts(417),
     $     real(mini(417)),real(maxi(417)),0)
      call hbook1(418,' cos(theta(W+,f2*)) ',parts(418),
     $     real(mini(418)),real(maxi(418)),0)
      call hbook1(419,' cos(theta(W-,f3*)) ',parts(419),
     $     real(mini(419)),real(maxi(419)),0)
      call hbook1(420,' cos(theta(W-,f4*)) ',parts(420),
     $     real(mini(420)),real(maxi(420)),0)
c Azimuthal angles:
      call hbook1(421,' Phi ',parts(421),
     $     real(mini(421)),real(maxi(421)),0)
      call hbook1(422,' phi(W+) ',parts(422),
     $     real(mini(422)),real(maxi(422)),0)
      call hbook1(423,' phi(W-) ',parts(423),
     $     real(mini(423)),real(maxi(423)),0)
c
      call hbook1(424,' cos(theta(f1,f2)) ',parts(424),
     $     real(mini(424)),real(maxi(424)),0)
      call hbook1(425,' cos(theta(f3,f4)) ',parts(425),
     $     real(mini(425)),real(maxi(425)),0)
c
c 2->5 plots:
c
      call hbook1(501,' tot. sigma ',parts(501),
     $     real(mini(501)),real(maxi(501)),0)
      call hbook1(502,' M(W+) ',parts(502),
     $     real(mini(502)),real(maxi(502)),0)
      call hbook1(503,' M(W-) ',parts(503),
     $     real(mini(503)),real(maxi(503)),0)
c production angles:
      call hbook1(504,' cos(theta(W+)) ',parts(504),
     $     real(mini(504)),real(maxi(504)),0)
      call hbook1(505,' cos(theta(W-)) ',parts(505),
     $     real(mini(505)),real(maxi(505)),0)
c scattering angles:
      call hbook1(506,' cos(theta(W+,f1)) ',parts(506),
     $     real(mini(506)),real(maxi(506)),0)
      call hbook1(507,' cos(theta(W+,f2)) ',parts(507),
     $     real(mini(507)),real(maxi(507)),0)
      call hbook1(508,' cos(theta(W-,f3)) ',parts(508),
     $     real(mini(508)),real(maxi(508)),0)
      call hbook1(509,' cos(theta(W-,f4)) ',parts(509),
     $     real(mini(509)),real(maxi(509)),0)
c
      call hbook1(513,' E fermion1$',parts(513),
     $     real(mini(513)),real(maxi(513)),0)
      call hbook1(514,' E fermion2$',parts(514),
     $     real(mini(514)),real(maxi(514)),0)
      call hbook1(515,' E fermion3$',parts(515),
     $     real(mini(515)),real(maxi(515)),0)
      call hbook1(516,' E fermion4$',parts(516),
     $     real(mini(516)),real(maxi(516)),0)
c scattering angles in W CMS:
      call hbook1(517,' cos(theta(W+,f1*)) ',parts(517),
     $     real(mini(517)),real(maxi(517)),0)
      call hbook1(518,' cos(theta(W+,f2*)) ',parts(518),
     $     real(mini(518)),real(maxi(518)),0)
      call hbook1(519,' cos(theta(W-,f3*)) ',parts(519),
     $     real(mini(519)),real(maxi(519)),0)
      call hbook1(520,' cos(theta(W-,f4*)) ',parts(520),
     $     real(mini(520)),real(maxi(520)),0)
c Azimuthal angles:
      call hbook1(521,' Phi ',parts(521),
     $     real(mini(521)),real(maxi(521)),0)
      call hbook1(522,' phi(W+) ',parts(522),
     $     real(mini(522)),real(maxi(522)),0)
      call hbook1(523,' phi(W-) ',parts(523),
     $     real(mini(523)),real(maxi(523)),0)
c
      call hbook1(524,' cos(theta(f1,f2)) ',parts(524),
     $     real(mini(524)),real(maxi(524)),0)
      call hbook1(525,' cos(theta(f3,f4)) ',parts(525),
     $     real(mini(525)),real(maxi(525)),0)
      return
      end
	
      subroutine graphs(smc,n,q,dsig,wgt)
      implicit none
      integer i,j,n,it,smc
      integer dsdc,dsdcg
      integer hmax,bmax
      parameter(hmax=1000)
      parameter(bmax=2000)
      integer parts(hmax),nmax
      parameter(nmax=10)
      real*8 dsig,wgt,wi(hmax),q(6),wis(hmax)
      real*8 pm,bmp,bmm
      real*8 res,dot_4,pwp(4),pwm(4)
      real*8 pwpep(3),pwpfwpep(3),pwpfwmf(3),pwpf(3),pwmf(3),cosp,pi
      real*8 gammab(4),ps(3),pwmem(3),pwmfwmem(3)
      real*8 deltas,deltac,deltags,deltagc,loglow,logup
      real*8 p(4,nmax),b(4,2)
      real*8 ctheta(4,5),theta_rec(4),thetf_min
      real*8 mini(hmax),maxi(hmax),stepi(hmax)
c event 
      integer maxe
      parameter(maxe=29)
      real*8 weight(maxe),pbeam(2,0:3),pss(7,0:3,maxe)
      real*8 weightborn,pborn(7,0:3)
      integer nsubevent
c rcoptions      
      integer qborn,qreal,qqcd,qbos,qferm,qsoft,qnf,qfast

      common/choice/dsdc,dsdcg
      common/par_dsdc/loglow,logup
      common/tcuts/deltas,deltac,deltags,deltagc
      common/hloc/parts,mini,maxi,stepi
      common/event/weight,pbeam,pss,weightborn,pborn,nsubevent 
      common/rcoptions/qborn,qreal,qqcd,qbos,qferm,qsoft,qnf,qfast

      pi=4d0*datan(1d0)
      do i=1,3
         b(i,1)=pbeam(1,i)
         b(i,2)=pbeam(2,i)
         do j=1,5
            p(i,j)=pss(j+2,i,n)
         end do
      end do
      b(4,1)=pbeam(1,0)
      b(4,2)=pbeam(2,0)
      do j=1,5
         p(4,j)=pss(j+2,0,n)
      end do

      it=1
      do i=1,hmax
         wi(i)=wgt*dsig/(it*stepi(i))
      end do

      if (smc.ne.2) then
         if (dsdc.eq.1) then
            call dfill(101,log10(deltas),0.d0,wi(101))
         else if(dsdc.eq.2) then
            call dfill(101,log10(deltac),0.d0,wi(101))
         end if
         if (dsdcg.eq.1) then
            call dfill(101,log10(deltags),0.d0,wi(101))
         else if(dsdcg.eq.2) then
            call dfill(101,log10(deltagc),0.d0,wi(101))
         end if
      end if

c total cross section      
      call dfill(1,0d0,0.d0,wi(1))

      bmp=dsqrt(b(1,1)**2+b(2,1)**2+b(3,1)**2)
      bmm=dsqrt(b(1,2)**2+b(2,2)**2+b(3,2)**2)
c inv. mass distributions:
c W+
      res=dsqrt(2d0*dot_4(p(1,1),p(1,2))+p(4,1)**2-(p(3,1)**2+
     $     p(2,1)**2+p(1,1)**2)+p(4,2)**2-(p(3,2)**2+
     $     p(2,2)**2+p(1,2)**2))
      call dfill(2,res,0.d0,wi(2))
c W-
      res=dsqrt(2d0*dot_4(p(1,3),p(1,4))+p(4,3)**2-(p(3,3)**2+
     $     p(2,3)**2+p(1,3)**2)+p(4,4)**2-(p(3,4)**2+
     $     p(2,4)**2+p(1,4)**2))
      call dfill(3,res,0.d0,wi(3))

      do i=1,4
         pwp(i)=p(i,1)+p(i,2)
         pwm(i)=p(i,3)+p(i,4)
      end do
c production angles:       
c W+,e+
      res=(b(1,1)*pwp(1)+b(2,1)*pwp(2)+b(3,1)*pwp(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/bmp
      call dfill(4,res,0.d0,wi(4))
c W-,e-
      res=(b(1,2)*pwm(1)+b(2,2)*pwm(2)+b(3,2)*pwm(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/bmm
      call dfill(5,res,0.d0,wi(5))
c scattering angles:
c W+ f:
      do i=1,2
         res=(pwp(1)*p(1,i)+pwp(2)*p(2,i)+pwp(3)*p(3,i))
     $        /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(p(1,i)**2+
     $        p(2,i)**2+p(3,i)**2)
         call dfill(i+5,res,0.d0,wi(i+5))
      end do
c W- f:
      do i=3,4
         res=(pwm(1)*p(1,i)+pwm(2)*p(2,i)+pwm(3)*p(3,i))
     $        /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(p(1,i)**2+
     $        p(2,i)**2+p(3,i)**2)
         call dfill(i+5,res,0.d0,wi(i+5))
      end do
      wis(10)=wi(10)
      wis(11)=wi(11)
      wis(12)=wi(12)
      if(qqcd.eq.1.or.qqcd.eq.3)then
         if((smc.eq.2.and.n.ne.6).or.
     $        (smc.ne.2.and.n.ne.7))then
            wis(10)=0d0
            wis(11)=0d0
            wis(12)=0d0
         endif
      endif
c photon energy
      call dfill(10,p(4,5),0.d0,wis(10))
      pm=dsqrt(p(1,5)**2+p(2,5)**2+p(3,5)**2)
      if (pm.ne.0d0) then
         res=(b(1,1)*p(1,5)+b(2,1)*p(2,5)+b(3,1)*p(3,5))/pm/bmp
         call dfill(11,res,0.d0,wis(11))
         thetf_min=180d0
         do i=1,4
            if (q(i+2).ne.0d0) then
               ctheta(i,5)=(p(1,5)*p(1,i)+p(2,5)*p(2,i)+
     $              p(3,5)*p(3,i))/pm/
     $              dsqrt(p(1,i)**2+p(2,i)**2+p(3,i)**2)
               theta_rec(i)=dacos(ctheta(i,5))*180d0/pi
               if (theta_rec(i).lt.thetf_min) thetf_min=theta_rec(i)
            end if
         end do
         call dfill(12,thetf_min,0.d0,wis(12))
      else
         res=maxi(11)-stepi(11)/10d0
         call dfill(11,res,0.d0,wis(11))
         call dfill(12,mini(12),0.d0,wis(12))
      end if
c energy distributions:
      do i=1,4
         call dfill(i+12,p(4,i),0.d0,wi(i+12))
      end do
c scattering angles in W CMS:
c W+ f*
      do i=1,4
         gammab(i)=pwp(i)/
     $        dsqrt(pwp(4)**2-(pwp(1)**2+pwp(2)**2+pwp(3)**2))
      end do
c boost f1 momentum to W+ CMS:
      do i=1,3
         ps(i)=p(i,1)+gammab(i)*
     $        ((gammab(1)*p(1,1)+gammab(2)*p(2,1)+gammab(3)*p(3,1))/
     $        (1d0+gammab(4))-p(4,1))
      end do
      res=(pwp(1)*ps(1)+pwp(2)*ps(2)+pwp(3)*ps(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(17,res,0.d0,wi(17))
c boost f2 momentum to W+ CMS:
      do i=1,3
         ps(i)=p(i,2)+gammab(i)*
     $        ((gammab(1)*p(1,2)+gammab(2)*p(2,2)+gammab(3)*p(3,2))/
     $        (1d0+gammab(4))-p(4,2))
      end do
      res=(pwp(1)*ps(1)+pwp(2)*ps(2)+pwp(3)*ps(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(18,res,0.d0,wi(18))
c W- f*
      do i=1,4
         gammab(i)=pwm(i)/
     $        dsqrt(pwm(4)**2-(pwm(1)**2+pwm(2)**2+pwm(3)**2))
      end do
c boost f3 momentum to W- CMS:
      do i=1,3
         ps(i)=p(i,3)+gammab(i)*
     $        ((gammab(1)*p(1,3)+gammab(2)*p(2,3)+gammab(3)*p(3,3))/
     $        (1d0+gammab(4))-p(4,3))
      end do
      res=(pwm(1)*ps(1)+pwm(2)*ps(2)+pwm(3)*ps(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(19,res,0.d0,wi(19))
c boost f4 momentum to W- CMS:
      do i=1,3
         ps(i)=p(i,4)+gammab(i)*
     $        ((gammab(1)*p(1,4)+gammab(2)*p(2,4)+gammab(3)*p(3,4))/
     $        (1d0+gammab(4))-p(4,4))
      end do
      res=(pwm(1)*ps(1)+pwm(2)*ps(2)+pwm(3)*ps(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(20,res,0.d0,wi(20))
c azimuthal angles:
      pwpf(1)=pwp(2)*p(3,1)-pwp(3)*p(2,1)
      pwpf(2)=pwp(3)*p(1,1)-pwp(1)*p(3,1)
      pwpf(3)=pwp(1)*p(2,1)-pwp(2)*p(1,1)
      pwmf(1)=-pwm(2)*p(3,3)+pwm(3)*p(2,3)
      pwmf(2)=-pwm(3)*p(1,3)+pwm(1)*p(3,3)
      pwmf(3)=-pwm(1)*p(2,3)+pwm(2)*p(1,3)
      pwpfwmf(1)=pwpf(2)*pwmf(3)-pwpf(3)*pwmf(2)
      pwpfwmf(2)=pwpf(3)*pwmf(1)-pwpf(1)*pwmf(3)
      pwpfwmf(3)=pwpf(1)*pwmf(2)-pwpf(2)*pwmf(1)
      cosp=(pwpf(1)*pwmf(1)+pwpf(2)*pwmf(2)+pwpf(3)*pwmf(3))
     $     /dsqrt(pwpf(1)**2+pwpf(2)**2+pwpf(3)**2)
     $     /dsqrt(pwmf(1)**2+pwmf(2)**2+pwmf(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwp(1)*pwpfwmf(1)+pwp(2)*pwpfwmf(2)+
     $     pwp(3)*pwpfwmf(3)).lt.0d0) res=360d0-res
      call dfill(21,res,0.d0,wi(21))
      pwpep(1)=pwp(2)*b(3,1)-pwp(3)*b(2,1)
      pwpep(2)=pwp(3)*b(1,1)-pwp(1)*b(3,1)
      pwpep(3)=pwp(1)*b(2,1)-pwp(2)*b(1,1)
      pwpfwpep(1)=pwpep(2)*pwpf(3)-pwpep(3)*pwpf(2)
      pwpfwpep(2)=pwpep(3)*pwpf(1)-pwpep(1)*pwpf(3)
      pwpfwpep(3)=pwpep(1)*pwpf(2)-pwpep(2)*pwpf(1)
      cosp=(pwpf(1)*pwpep(1)+pwpf(2)*pwpep(2)+pwpf(3)*pwpep(3))
     $     /dsqrt(pwpf(1)**2+pwpf(2)**2+pwpf(3)**2)
     $     /dsqrt(pwpep(1)**2+pwpep(2)**2+pwpep(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwp(1)*pwpfwpep(1)+pwp(2)*pwpfwpep(2)+
     $     pwp(3)*pwpfwpep(3)).lt.0d0) res=360d0-res
      call dfill(22,res,0.d0,wi(22))
      pwmem(1)=pwm(2)*b(3,2)-pwm(3)*b(2,2)
      pwmem(2)=pwm(3)*b(1,2)-pwm(1)*b(3,2)
      pwmem(3)=pwm(1)*b(2,2)-pwm(2)*b(1,2)
      pwmfwmem(1)=-pwmem(2)*pwmf(3)+pwmem(3)*pwmf(2)
      pwmfwmem(2)=-pwmem(3)*pwmf(1)+pwmem(1)*pwmf(3)
      pwmfwmem(3)=-pwmem(1)*pwmf(2)+pwmem(2)*pwmf(1)
      cosp=(-pwmf(1)*pwmem(1)-pwmf(2)*pwmem(2)-pwmf(3)*pwmem(3))
     $     /dsqrt(pwmf(1)**2+pwmf(2)**2+pwmf(3)**2)
     $     /dsqrt(pwmem(1)**2+pwmem(2)**2+pwmem(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwm(1)*pwmfwmem(1)+pwm(2)*pwmfwmem(2)+
     $     pwm(3)*pwmfwmem(3)).lt.0d0) res=360d0-res
      call dfill(23,res,0.d0,wi(23))
c opening angles:
c f1,f2:
      res=(p(1,1)*p(1,2)+p(2,1)*p(2,2)+p(3,1)*p(3,2))
     $     /dsqrt(p(1,1)**2+p(2,1)**2+p(3,1)**2)/dsqrt(p(1,2)**2+
     $     p(2,2)**2+p(3,2)**2)
      call dfill(24,res,0.d0,wi(24))
c f3,f4:
      res=(p(1,3)*p(1,4)+p(2,3)*p(2,4)+p(3,3)*p(3,4))
     $     /dsqrt(p(1,3)**2+p(2,3)**2+p(3,3)**2)/dsqrt(p(1,4)**2+
     $     p(2,4)**2+p(3,4)**2)
      call dfill(25,res,0.d0,wi(25))
      return
      end

      subroutine graphs_b(smc,n,dsig,wgt)
      implicit none
      integer i,j,n,it,smc
      integer hmax,bmax
      parameter(hmax=1000)
      parameter(bmax=2000)
      integer parts(hmax),nmax
      parameter(nmax=10)
      real*8 dsig,wgt,wi(hmax)
      real*8 pm,bmp,bmm
      real*8 res,dot_4,pwp(4),pwm(4)
      real*8 pwpep(3),pwpfwpep(3),pwpfwmf(3),pwpf(3),pwmf(3),cosp,pi
      real*8 gammab(4),ps(3),pwmem(3),pwmfwmem(3)
      real*8 p(4,nmax),b(4,2)
      real*8 ctheta(4,5),theta_rec(4),thetf_min
      real*8 mini(hmax),maxi(hmax),stepi(hmax)
c event 
      integer maxe
      parameter(maxe=29)
      real*8 weight(maxe),pbeam(2,0:3),pss(7,0:3,maxe)
      real*8 weightborn,pborn(7,0:3)
      integer nsubevent

      common/hloc/parts,mini,maxi,stepi
      common/event/weight,pbeam,pss,weightborn,pborn,nsubevent 

      pi=4d0*datan(1d0)
      do i=1,3
         b(i,1)=pbeam(1,i)
         b(i,2)=pbeam(2,i)
         do j=1,5
            p(i,j)=pborn(j+2,i)
         end do
      end do
      b(4,1)=pbeam(1,0)
      b(4,2)=pbeam(2,0)
      do j=1,5
         p(4,j)=pborn(j+2,0)
      end do

      it=1
      do i=1,hmax
         wi(i)=wgt*dsig/(it*stepi(i))
      end do

c total cross section      
      call dfill(201,0d0,0.d0,wi(201))

      bmp=dsqrt(b(1,1)**2+b(2,1)**2+b(3,1)**2)
      bmm=dsqrt(b(1,2)**2+b(2,2)**2+b(3,2)**2)
c inv. mass distributions:
c W+
      res=dsqrt(2d0*dot_4(p(1,1),p(1,2))+p(4,1)**2-(p(3,1)**2+
     $     p(2,1)**2+p(1,1)**2)+p(4,2)**2-(p(3,2)**2+
     $     p(2,2)**2+p(1,2)**2))
      call dfill(202,res,0.d0,wi(202))
c W-
      res=dsqrt(2d0*dot_4(p(1,3),p(1,4))+p(4,3)**2-(p(3,3)**2+
     $     p(2,3)**2+p(1,3)**2)+p(4,4)**2-(p(3,4)**2+
     $     p(2,4)**2+p(1,4)**2))
      call dfill(203,res,0.d0,wi(203))

      do i=1,4
         pwp(i)=p(i,1)+p(i,2)
         pwm(i)=p(i,3)+p(i,4)
      end do
c production angles:       
c W+,e+
      res=(b(1,1)*pwp(1)+b(2,1)*pwp(2)+b(3,1)*pwp(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/bmp
      call dfill(204,res,0.d0,wi(204))
c W-,e-
      res=(b(1,2)*pwm(1)+b(2,2)*pwm(2)+b(3,2)*pwm(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/bmm
      call dfill(205,res,0.d0,wi(205))
c scattering angles:
c W+ f:
      do i=1,2
         res=(pwp(1)*p(1,i)+pwp(2)*p(2,i)+pwp(3)*p(3,i))
     $        /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(p(1,i)**2+
     $        p(2,i)**2+p(3,i)**2)
         call dfill(i+205,res,0.d0,wi(i+205))
      end do
c W- f:
      do i=3,4
         res=(pwm(1)*p(1,i)+pwm(2)*p(2,i)+pwm(3)*p(3,i))
     $        /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(p(1,i)**2+
     $        p(2,i)**2+p(3,i)**2)
         call dfill(i+205,res,0.d0,wi(i+205))
      end do
c energy distributions:
      do i=1,4
         call dfill(i+212,p(4,i),0.d0,wi(i+212))
      end do
c scattering angles in W CMS:
c W+ f*
      do i=1,4
         gammab(i)=pwp(i)/
     $        dsqrt(pwp(4)**2-(pwp(1)**2+pwp(2)**2+pwp(3)**2))
      end do
c boost f1 momentum to W+ CMS:
      do i=1,3
         ps(i)=p(i,1)+gammab(i)*
     $        ((gammab(1)*p(1,1)+gammab(2)*p(2,1)+gammab(3)*p(3,1))/
     $        (1d0+gammab(4))-p(4,1))
      end do
      res=(pwp(1)*ps(1)+pwp(2)*ps(2)+pwp(3)*ps(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(217,res,0.d0,wi(217))
c boost f2 momentum to W+ CMS:
      do i=1,3
         ps(i)=p(i,2)+gammab(i)*
     $        ((gammab(1)*p(1,2)+gammab(2)*p(2,2)+gammab(3)*p(3,2))/
     $        (1d0+gammab(4))-p(4,2))
      end do
      res=(pwp(1)*ps(1)+pwp(2)*ps(2)+pwp(3)*ps(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(218,res,0.d0,wi(218))
c W- f*
      do i=1,4
         gammab(i)=pwm(i)/
     $        dsqrt(pwm(4)**2-(pwm(1)**2+pwm(2)**2+pwm(3)**2))
      end do
c boost f3 momentum to W- CMS:
      do i=1,3
         ps(i)=p(i,3)+gammab(i)*
     $        ((gammab(1)*p(1,3)+gammab(2)*p(2,3)+gammab(3)*p(3,3))/
     $        (1d0+gammab(4))-p(4,3))
      end do
      res=(pwm(1)*ps(1)+pwm(2)*ps(2)+pwm(3)*ps(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(219,res,0.d0,wi(219))
c boost f4 momentum to W- CMS:
      do i=1,3
         ps(i)=p(i,4)+gammab(i)*
     $        ((gammab(1)*p(1,4)+gammab(2)*p(2,4)+gammab(3)*p(3,4))/
     $        (1d0+gammab(4))-p(4,4))
      end do
      res=(pwm(1)*ps(1)+pwm(2)*ps(2)+pwm(3)*ps(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(220,res,0.d0,wi(220))
c azimuthal angles:
      pwpf(1)=pwp(2)*p(3,1)-pwp(3)*p(2,1)
      pwpf(2)=pwp(3)*p(1,1)-pwp(1)*p(3,1)
      pwpf(3)=pwp(1)*p(2,1)-pwp(2)*p(1,1)
      pwmf(1)=-pwm(2)*p(3,3)+pwm(3)*p(2,3)
      pwmf(2)=-pwm(3)*p(1,3)+pwm(1)*p(3,3)
      pwmf(3)=-pwm(1)*p(2,3)+pwm(2)*p(1,3)
      pwpfwmf(1)=pwpf(2)*pwmf(3)-pwpf(3)*pwmf(2)
      pwpfwmf(2)=pwpf(3)*pwmf(1)-pwpf(1)*pwmf(3)
      pwpfwmf(3)=pwpf(1)*pwmf(2)-pwpf(2)*pwmf(1)
      cosp=(pwpf(1)*pwmf(1)+pwpf(2)*pwmf(2)+pwpf(3)*pwmf(3))
     $     /dsqrt(pwpf(1)**2+pwpf(2)**2+pwpf(3)**2)
     $     /dsqrt(pwmf(1)**2+pwmf(2)**2+pwmf(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwp(1)*pwpfwmf(1)+pwp(2)*pwpfwmf(2)+
     $     pwp(3)*pwpfwmf(3)).lt.0d0) res=360d0-res
      call dfill(221,res,0.d0,wi(221))
      pwpep(1)=pwp(2)*b(3,1)-pwp(3)*b(2,1)
      pwpep(2)=pwp(3)*b(1,1)-pwp(1)*b(3,1)
      pwpep(3)=pwp(1)*b(2,1)-pwp(2)*b(1,1)
      pwpfwpep(1)=pwpep(2)*pwpf(3)-pwpep(3)*pwpf(2)
      pwpfwpep(2)=pwpep(3)*pwpf(1)-pwpep(1)*pwpf(3)
      pwpfwpep(3)=pwpep(1)*pwpf(2)-pwpep(2)*pwpf(1)
      cosp=(pwpf(1)*pwpep(1)+pwpf(2)*pwpep(2)+pwpf(3)*pwpep(3))
     $     /dsqrt(pwpf(1)**2+pwpf(2)**2+pwpf(3)**2)
     $     /dsqrt(pwpep(1)**2+pwpep(2)**2+pwpep(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwp(1)*pwpfwpep(1)+pwp(2)*pwpfwpep(2)+
     $     pwp(3)*pwpfwpep(3)).lt.0d0) res=360d0-res
      call dfill(222,res,0.d0,wi(222))
      pwmem(1)=pwm(2)*b(3,2)-pwm(3)*b(2,2)
      pwmem(2)=pwm(3)*b(1,2)-pwm(1)*b(3,2)
      pwmem(3)=pwm(1)*b(2,2)-pwm(2)*b(1,2)
      pwmfwmem(1)=-pwmem(2)*pwmf(3)+pwmem(3)*pwmf(2)
      pwmfwmem(2)=-pwmem(3)*pwmf(1)+pwmem(1)*pwmf(3)
      pwmfwmem(3)=-pwmem(1)*pwmf(2)+pwmem(2)*pwmf(1)
      cosp=(-pwmf(1)*pwmem(1)-pwmf(2)*pwmem(2)-pwmf(3)*pwmem(3))
     $     /dsqrt(pwmf(1)**2+pwmf(2)**2+pwmf(3)**2)
     $     /dsqrt(pwmem(1)**2+pwmem(2)**2+pwmem(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwm(1)*pwmfwmem(1)+pwm(2)*pwmfwmem(2)+
     $     pwm(3)*pwmfwmem(3)).lt.0d0) res=360d0-res
      call dfill(223,res,0.d0,wi(223))
c opening angles:
c f1,f2:
      res=(p(1,1)*p(1,2)+p(2,1)*p(2,2)+p(3,1)*p(3,2))
     $     /dsqrt(p(1,1)**2+p(2,1)**2+p(3,1)**2)/dsqrt(p(1,2)**2+
     $     p(2,2)**2+p(3,2)**2)
      call dfill(224,res,0.d0,wi(224))
c f3,f4:
      res=(p(1,3)*p(1,4)+p(2,3)*p(2,4)+p(3,3)*p(3,4))
     $     /dsqrt(p(1,3)**2+p(2,3)**2+p(3,3)**2)/dsqrt(p(1,4)**2+
     $     p(2,4)**2+p(3,4)**2)
      call dfill(225,res,0.d0,wi(225))
      return
      end

      subroutine graphs_k(smc,n,dsig,wgt)
      implicit none
      integer i,j,n,it,smc
      integer dsdc,dsdcg
      integer hmax,bmax
      parameter(hmax=1000)
      parameter(bmax=2000)
      integer parts(hmax),nmax
      parameter(nmax=10)
      real*8 dsig,wgt,wi(hmax)
      real*8 pm,bmp,bmm
      real*8 res,dot_4,pwp(4),pwm(4)
      real*8 pwpep(3),pwpfwpep(3),pwpfwmf(3),pwpf(3),pwmf(3),cosp,pi
      real*8 gammab(4),ps(3),pwmem(3),pwmfwmem(3)
      real*8 deltas,deltac,deltags,deltagc,loglow,logup
      real*8 p(4,nmax),b(4,2)
      real*8 ctheta(4,5),theta_rec(4),thetf_min
      real*8 mini(hmax),maxi(hmax),stepi(hmax)
c event 
      integer maxe
      parameter(maxe=29)
      real*8 weight(maxe),pbeam(2,0:3),pss(7,0:3,maxe)
      real*8 weightborn,pborn(7,0:3)
      integer nsubevent

      common/choice/dsdc,dsdcg
      common/par_dsdc/loglow,logup
      common/tcuts/deltas,deltac,deltags,deltagc
      common/hloc/parts,mini,maxi,stepi
      common/event/weight,pbeam,pss,weightborn,pborn,nsubevent 

      pi=4d0*datan(1d0)
      do i=1,3
         b(i,1)=pbeam(1,i)
         b(i,2)=pbeam(2,i)
         do j=1,5
            p(i,j)=pss(j+2,i,n)
         end do
      end do
      b(4,1)=pbeam(1,0)
      b(4,2)=pbeam(2,0)
      do j=1,5
         p(4,j)=pss(j+2,0,n)
      end do

      it=1
      do i=1,hmax
         wi(i)=wgt*dsig/(it*stepi(i))
      end do

      if (smc.ne.2) then
         if (dsdc.eq.1) then
            call dfill(102,log10(deltas),0.d0,wi(102))
         else if(dsdc.eq.2) then
            call dfill(102,log10(deltac),0.d0,wi(102))
         end if
         if (dsdcg.eq.1) then
            call dfill(102,log10(deltags),0.d0,wi(102))
         else if(dsdcg.eq.2) then
            call dfill(102,log10(deltagc),0.d0,wi(102))
         end if
      end if

c total cross section      
      call dfill(401,0d0,0.d0,wi(401))

      bmp=dsqrt(b(1,1)**2+b(2,1)**2+b(3,1)**2)
      bmm=dsqrt(b(1,2)**2+b(2,2)**2+b(3,2)**2)
c inv. mass distributions:
c W+
      res=dsqrt(2d0*dot_4(p(1,1),p(1,2))+p(4,1)**2-(p(3,1)**2+
     $     p(2,1)**2+p(1,1)**2)+p(4,2)**2-(p(3,2)**2+
     $     p(2,2)**2+p(1,2)**2))
      call dfill(402,res,0.d0,wi(402))
c W-
      res=dsqrt(2d0*dot_4(p(1,3),p(1,4))+p(4,3)**2-(p(3,3)**2+
     $     p(2,3)**2+p(1,3)**2)+p(4,4)**2-(p(3,4)**2+
     $     p(2,4)**2+p(1,4)**2))
      call dfill(403,res,0.d0,wi(403))

      do i=1,4
         pwp(i)=p(i,1)+p(i,2)
         pwm(i)=p(i,3)+p(i,4)
      end do
c production angles:       
c W+,e+
      res=(b(1,1)*pwp(1)+b(2,1)*pwp(2)+b(3,1)*pwp(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/bmp
      call dfill(404,res,0.d0,wi(404))
c W-,e-
      res=(b(1,2)*pwm(1)+b(2,2)*pwm(2)+b(3,2)*pwm(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/bmm
      call dfill(405,res,0.d0,wi(405))
c scattering angles:
c W+ f:
      do i=1,2
         res=(pwp(1)*p(1,i)+pwp(2)*p(2,i)+pwp(3)*p(3,i))
     $        /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(p(1,i)**2+
     $        p(2,i)**2+p(3,i)**2)
         call dfill(i+405,res,0.d0,wi(i+405))
      end do
c W- f:
      do i=3,4
         res=(pwm(1)*p(1,i)+pwm(2)*p(2,i)+pwm(3)*p(3,i))
     $        /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(p(1,i)**2+
     $        p(2,i)**2+p(3,i)**2)
         call dfill(i+405,res,0.d0,wi(i+405))
      end do
c energy distributions:
      do i=1,4
         call dfill(i+412,p(4,i),0.d0,wi(i+412))
      end do
c scattering angles in W CMS:
c W+ f*
      do i=1,4
         gammab(i)=pwp(i)/
     $        dsqrt(pwp(4)**2-(pwp(1)**2+pwp(2)**2+pwp(3)**2))
      end do
c boost f1 momentum to W+ CMS:
      do i=1,3
         ps(i)=p(i,1)+gammab(i)*
     $        ((gammab(1)*p(1,1)+gammab(2)*p(2,1)+gammab(3)*p(3,1))/
     $        (1d0+gammab(4))-p(4,1))
      end do
      res=(pwp(1)*ps(1)+pwp(2)*ps(2)+pwp(3)*ps(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(417,res,0.d0,wi(417))
c boost f2 momentum to W+ CMS:
      do i=1,3
         ps(i)=p(i,2)+gammab(i)*
     $        ((gammab(1)*p(1,2)+gammab(2)*p(2,2)+gammab(3)*p(3,2))/
     $        (1d0+gammab(4))-p(4,2))
      end do
      res=(pwp(1)*ps(1)+pwp(2)*ps(2)+pwp(3)*ps(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(418,res,0.d0,wi(418))
c W- f*
      do i=1,4
         gammab(i)=pwm(i)/
     $        dsqrt(pwm(4)**2-(pwm(1)**2+pwm(2)**2+pwm(3)**2))
      end do
c boost f3 momentum to W- CMS:
      do i=1,3
         ps(i)=p(i,3)+gammab(i)*
     $        ((gammab(1)*p(1,3)+gammab(2)*p(2,3)+gammab(3)*p(3,3))/
     $        (1d0+gammab(4))-p(4,3))
      end do
      res=(pwm(1)*ps(1)+pwm(2)*ps(2)+pwm(3)*ps(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(419,res,0.d0,wi(419))
c boost f4 momentum to W- CMS:
      do i=1,3
         ps(i)=p(i,4)+gammab(i)*
     $        ((gammab(1)*p(1,4)+gammab(2)*p(2,4)+gammab(3)*p(3,4))/
     $        (1d0+gammab(4))-p(4,4))
      end do
      res=(pwm(1)*ps(1)+pwm(2)*ps(2)+pwm(3)*ps(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(420,res,0.d0,wi(420))
c azimuthal angles:
      pwpf(1)=pwp(2)*p(3,1)-pwp(3)*p(2,1)
      pwpf(2)=pwp(3)*p(1,1)-pwp(1)*p(3,1)
      pwpf(3)=pwp(1)*p(2,1)-pwp(2)*p(1,1)
      pwmf(1)=-pwm(2)*p(3,3)+pwm(3)*p(2,3)
      pwmf(2)=-pwm(3)*p(1,3)+pwm(1)*p(3,3)
      pwmf(3)=-pwm(1)*p(2,3)+pwm(2)*p(1,3)
      pwpfwmf(1)=pwpf(2)*pwmf(3)-pwpf(3)*pwmf(2)
      pwpfwmf(2)=pwpf(3)*pwmf(1)-pwpf(1)*pwmf(3)
      pwpfwmf(3)=pwpf(1)*pwmf(2)-pwpf(2)*pwmf(1)
      cosp=(pwpf(1)*pwmf(1)+pwpf(2)*pwmf(2)+pwpf(3)*pwmf(3))
     $     /dsqrt(pwpf(1)**2+pwpf(2)**2+pwpf(3)**2)
     $     /dsqrt(pwmf(1)**2+pwmf(2)**2+pwmf(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwp(1)*pwpfwmf(1)+pwp(2)*pwpfwmf(2)+
     $     pwp(3)*pwpfwmf(3)).lt.0d0) res=360d0-res
      call dfill(421,res,0.d0,wi(421))
      pwpep(1)=pwp(2)*b(3,1)-pwp(3)*b(2,1)
      pwpep(2)=pwp(3)*b(1,1)-pwp(1)*b(3,1)
      pwpep(3)=pwp(1)*b(2,1)-pwp(2)*b(1,1)
      pwpfwpep(1)=pwpep(2)*pwpf(3)-pwpep(3)*pwpf(2)
      pwpfwpep(2)=pwpep(3)*pwpf(1)-pwpep(1)*pwpf(3)
      pwpfwpep(3)=pwpep(1)*pwpf(2)-pwpep(2)*pwpf(1)
      cosp=(pwpf(1)*pwpep(1)+pwpf(2)*pwpep(2)+pwpf(3)*pwpep(3))
     $     /dsqrt(pwpf(1)**2+pwpf(2)**2+pwpf(3)**2)
     $     /dsqrt(pwpep(1)**2+pwpep(2)**2+pwpep(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwp(1)*pwpfwpep(1)+pwp(2)*pwpfwpep(2)+
     $     pwp(3)*pwpfwpep(3)).lt.0d0) res=360d0-res
      call dfill(422,res,0.d0,wi(422))
      pwmem(1)=pwm(2)*b(3,2)-pwm(3)*b(2,2)
      pwmem(2)=pwm(3)*b(1,2)-pwm(1)*b(3,2)
      pwmem(3)=pwm(1)*b(2,2)-pwm(2)*b(1,2)
      pwmfwmem(1)=-pwmem(2)*pwmf(3)+pwmem(3)*pwmf(2)
      pwmfwmem(2)=-pwmem(3)*pwmf(1)+pwmem(1)*pwmf(3)
      pwmfwmem(3)=-pwmem(1)*pwmf(2)+pwmem(2)*pwmf(1)
      cosp=(-pwmf(1)*pwmem(1)-pwmf(2)*pwmem(2)-pwmf(3)*pwmem(3))
     $     /dsqrt(pwmf(1)**2+pwmf(2)**2+pwmf(3)**2)
     $     /dsqrt(pwmem(1)**2+pwmem(2)**2+pwmem(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwm(1)*pwmfwmem(1)+pwm(2)*pwmfwmem(2)+
     $     pwm(3)*pwmfwmem(3)).lt.0d0) res=360d0-res
      call dfill(423,res,0.d0,wi(423))
c opening angles:
c f1,f2:
      res=(p(1,1)*p(1,2)+p(2,1)*p(2,2)+p(3,1)*p(3,2))
     $     /dsqrt(p(1,1)**2+p(2,1)**2+p(3,1)**2)/dsqrt(p(1,2)**2+
     $     p(2,2)**2+p(3,2)**2)
      call dfill(424,res,0.d0,wi(424))
c f3,f4:
      res=(p(1,3)*p(1,4)+p(2,3)*p(2,4)+p(3,3)*p(3,4))
     $     /dsqrt(p(1,3)**2+p(2,3)**2+p(3,3)**2)/dsqrt(p(1,4)**2+
     $     p(2,4)**2+p(3,4)**2)
      call dfill(425,res,0.d0,wi(425))
      return
      end

      subroutine graphs_r(smc,n,dsig,wgt)
      implicit none
      integer i,j,n,it,smc
      integer dsdc,dsdcg
      integer hmax,bmax
      parameter(hmax=1000)
      parameter(bmax=2000)
      integer parts(hmax),nmax
      parameter(nmax=10)
      real*8 dsig,wgt,wi(hmax)
      real*8 pm,bmp,bmm
      real*8 res,dot_4,pwp(4),pwm(4)
      real*8 pwpep(3),pwpfwpep(3),pwpfwmf(3),pwpf(3),pwmf(3),cosp,pi
      real*8 gammab(4),ps(3),pwmem(3),pwmfwmem(3)
      real*8 deltas,deltac,deltags,deltagc,loglow,logup
      real*8 p(4,nmax),b(4,2)
      real*8 ctheta(4,5),theta_rec(4),thetf_min
      real*8 mini(hmax),maxi(hmax),stepi(hmax)
c event 
      integer maxe
      parameter(maxe=29)
      real*8 weight(maxe),pbeam(2,0:3),pss(7,0:3,maxe)
      real*8 weightborn,pborn(7,0:3)
      integer nsubevent

      common/choice/dsdc,dsdcg
      common/par_dsdc/loglow,logup
      common/tcuts/deltas,deltac,deltags,deltagc
      common/hloc/parts,mini,maxi,stepi
      common/event/weight,pbeam,pss,weightborn,pborn,nsubevent 

      pi=4d0*datan(1d0)
      do i=1,3
         b(i,1)=pbeam(1,i)
         b(i,2)=pbeam(2,i)
         do j=1,5
            p(i,j)=pss(j+2,i,n)
         end do
      end do
      b(4,1)=pbeam(1,0)
      b(4,2)=pbeam(2,0)
      do j=1,5
         p(4,j)=pss(j+2,0,n)
      end do

      it=1
      do i=1,hmax
         wi(i)=wgt*dsig/(it*stepi(i))
      end do

      if (smc.ne.2) then
         if (dsdc.eq.1) then
            call dfill(103,log10(deltas),0.d0,wi(103))
         else if(dsdc.eq.2) then
            call dfill(103,log10(deltac),0.d0,wi(103))
         end if
         if (dsdcg.eq.1) then
            call dfill(103,log10(deltags),0.d0,wi(103))
         else if(dsdcg.eq.2) then
            call dfill(103,log10(deltagc),0.d0,wi(103))
         end if
      end if

c total cross section      
      call dfill(501,0d0,0.d0,wi(501))

      bmp=dsqrt(b(1,1)**2+b(2,1)**2+b(3,1)**2)
      bmm=dsqrt(b(1,2)**2+b(2,2)**2+b(3,2)**2)
c inv. mass distributions:
c W+
      res=dsqrt(2d0*dot_4(p(1,1),p(1,2))+p(4,1)**2-(p(3,1)**2+
     $     p(2,1)**2+p(1,1)**2)+p(4,2)**2-(p(3,2)**2+
     $     p(2,2)**2+p(1,2)**2))
      call dfill(502,res,0.d0,wi(502))
c W-
      res=dsqrt(2d0*dot_4(p(1,3),p(1,4))+p(4,3)**2-(p(3,3)**2+
     $     p(2,3)**2+p(1,3)**2)+p(4,4)**2-(p(3,4)**2+
     $     p(2,4)**2+p(1,4)**2))
      call dfill(503,res,0.d0,wi(503))

      do i=1,4
         pwp(i)=p(i,1)+p(i,2)
         pwm(i)=p(i,3)+p(i,4)
      end do
c production angles:       
c W+,e+
      res=(b(1,1)*pwp(1)+b(2,1)*pwp(2)+b(3,1)*pwp(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/bmp
      call dfill(504,res,0.d0,wi(504))
c W-,e-
      res=(b(1,2)*pwm(1)+b(2,2)*pwm(2)+b(3,2)*pwm(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/bmm
      call dfill(505,res,0.d0,wi(505))
c scattering angles:
c W+ f:
      do i=1,2
         res=(pwp(1)*p(1,i)+pwp(2)*p(2,i)+pwp(3)*p(3,i))
     $        /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(p(1,i)**2+
     $        p(2,i)**2+p(3,i)**2)
         call dfill(i+505,res,0.d0,wi(i+505))
      end do
c W- f:
      do i=3,4
         res=(pwm(1)*p(1,i)+pwm(2)*p(2,i)+pwm(3)*p(3,i))
     $        /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(p(1,i)**2+
     $        p(2,i)**2+p(3,i)**2)
         call dfill(i+505,res,0.d0,wi(i+505))
      end do
c energy distributions:
      do i=1,4
         call dfill(i+512,p(4,i),0.d0,wi(i+512))
      end do
c scattering angles in W CMS:
c W+ f*
      do i=1,4
         gammab(i)=pwp(i)/
     $        dsqrt(pwp(4)**2-(pwp(1)**2+pwp(2)**2+pwp(3)**2))
      end do
c boost f1 momentum to W+ CMS:
      do i=1,3
         ps(i)=p(i,1)+gammab(i)*
     $        ((gammab(1)*p(1,1)+gammab(2)*p(2,1)+gammab(3)*p(3,1))/
     $        (1d0+gammab(4))-p(4,1))
      end do
      res=(pwp(1)*ps(1)+pwp(2)*ps(2)+pwp(3)*ps(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(517,res,0.d0,wi(517))
c boost f2 momentum to W+ CMS:
      do i=1,3
         ps(i)=p(i,2)+gammab(i)*
     $        ((gammab(1)*p(1,2)+gammab(2)*p(2,2)+gammab(3)*p(3,2))/
     $        (1d0+gammab(4))-p(4,2))
      end do
      res=(pwp(1)*ps(1)+pwp(2)*ps(2)+pwp(3)*ps(3))
     $     /dsqrt(pwp(1)**2+pwp(2)**2+pwp(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(518,res,0.d0,wi(518))
c W- f*
      do i=1,4
         gammab(i)=pwm(i)/
     $        dsqrt(pwm(4)**2-(pwm(1)**2+pwm(2)**2+pwm(3)**2))
      end do
c boost f3 momentum to W- CMS:
      do i=1,3
         ps(i)=p(i,3)+gammab(i)*
     $        ((gammab(1)*p(1,3)+gammab(2)*p(2,3)+gammab(3)*p(3,3))/
     $        (1d0+gammab(4))-p(4,3))
      end do
      res=(pwm(1)*ps(1)+pwm(2)*ps(2)+pwm(3)*ps(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(519,res,0.d0,wi(519))
c boost f4 momentum to W- CMS:
      do i=1,3
         ps(i)=p(i,4)+gammab(i)*
     $        ((gammab(1)*p(1,4)+gammab(2)*p(2,4)+gammab(3)*p(3,4))/
     $        (1d0+gammab(4))-p(4,4))
      end do
      res=(pwm(1)*ps(1)+pwm(2)*ps(2)+pwm(3)*ps(3))
     $     /dsqrt(pwm(1)**2+pwm(2)**2+pwm(3)**2)/dsqrt(ps(1)**2+
     $     ps(2)**2+ps(3)**2)
      call dfill(520,res,0.d0,wi(520))
c azimuthal angles:
      pwpf(1)=pwp(2)*p(3,1)-pwp(3)*p(2,1)
      pwpf(2)=pwp(3)*p(1,1)-pwp(1)*p(3,1)
      pwpf(3)=pwp(1)*p(2,1)-pwp(2)*p(1,1)
      pwmf(1)=-pwm(2)*p(3,3)+pwm(3)*p(2,3)
      pwmf(2)=-pwm(3)*p(1,3)+pwm(1)*p(3,3)
      pwmf(3)=-pwm(1)*p(2,3)+pwm(2)*p(1,3)
      pwpfwmf(1)=pwpf(2)*pwmf(3)-pwpf(3)*pwmf(2)
      pwpfwmf(2)=pwpf(3)*pwmf(1)-pwpf(1)*pwmf(3)
      pwpfwmf(3)=pwpf(1)*pwmf(2)-pwpf(2)*pwmf(1)
      cosp=(pwpf(1)*pwmf(1)+pwpf(2)*pwmf(2)+pwpf(3)*pwmf(3))
     $     /dsqrt(pwpf(1)**2+pwpf(2)**2+pwpf(3)**2)
     $     /dsqrt(pwmf(1)**2+pwmf(2)**2+pwmf(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwp(1)*pwpfwmf(1)+pwp(2)*pwpfwmf(2)+
     $     pwp(3)*pwpfwmf(3)).lt.0d0) res=360d0-res
      call dfill(521,res,0.d0,wi(521))
      pwpep(1)=pwp(2)*b(3,1)-pwp(3)*b(2,1)
      pwpep(2)=pwp(3)*b(1,1)-pwp(1)*b(3,1)
      pwpep(3)=pwp(1)*b(2,1)-pwp(2)*b(1,1)
      pwpfwpep(1)=pwpep(2)*pwpf(3)-pwpep(3)*pwpf(2)
      pwpfwpep(2)=pwpep(3)*pwpf(1)-pwpep(1)*pwpf(3)
      pwpfwpep(3)=pwpep(1)*pwpf(2)-pwpep(2)*pwpf(1)
      cosp=(pwpf(1)*pwpep(1)+pwpf(2)*pwpep(2)+pwpf(3)*pwpep(3))
     $     /dsqrt(pwpf(1)**2+pwpf(2)**2+pwpf(3)**2)
     $     /dsqrt(pwpep(1)**2+pwpep(2)**2+pwpep(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwp(1)*pwpfwpep(1)+pwp(2)*pwpfwpep(2)+
     $     pwp(3)*pwpfwpep(3)).lt.0d0) res=360d0-res
      call dfill(522,res,0.d0,wi(522))
      pwmem(1)=pwm(2)*b(3,2)-pwm(3)*b(2,2)
      pwmem(2)=pwm(3)*b(1,2)-pwm(1)*b(3,2)
      pwmem(3)=pwm(1)*b(2,2)-pwm(2)*b(1,2)
      pwmfwmem(1)=-pwmem(2)*pwmf(3)+pwmem(3)*pwmf(2)
      pwmfwmem(2)=-pwmem(3)*pwmf(1)+pwmem(1)*pwmf(3)
      pwmfwmem(3)=-pwmem(1)*pwmf(2)+pwmem(2)*pwmf(1)
      cosp=(-pwmf(1)*pwmem(1)-pwmf(2)*pwmem(2)-pwmf(3)*pwmem(3))
     $     /dsqrt(pwmf(1)**2+pwmf(2)**2+pwmf(3)**2)
     $     /dsqrt(pwmem(1)**2+pwmem(2)**2+pwmem(3)**2)
      res=dacos(cosp)*180d0/pi
      if ((pwm(1)*pwmfwmem(1)+pwm(2)*pwmfwmem(2)+
     $     pwm(3)*pwmfwmem(3)).lt.0d0) res=360d0-res
      call dfill(523,res,0.d0,wi(523))
c opening angles:
c f1,f2:
      res=(p(1,1)*p(1,2)+p(2,1)*p(2,2)+p(3,1)*p(3,2))
     $     /dsqrt(p(1,1)**2+p(2,1)**2+p(3,1)**2)/dsqrt(p(1,2)**2+
     $     p(2,2)**2+p(3,2)**2)
      call dfill(524,res,0.d0,wi(524))
c f3,f4:
      res=(p(1,3)*p(1,4)+p(2,3)*p(2,4)+p(3,3)*p(3,4))
     $     /dsqrt(p(1,3)**2+p(2,3)**2+p(3,3)**2)/dsqrt(p(1,4)**2+
     $     p(2,4)**2+p(3,4)**2)
      call dfill(525,res,0.d0,wi(525))
      return
      end

      subroutine dfill(i,x,y,wgt)
      implicit none
      integer i
      real*8 x,y,wgt
      real dx,dy,dwgt
      dx=real(x)
      dy=real(y)
      dwgt=real(wgt)
c     call hfill(i,dx,dy,dwgt)
      call hf1(i,dx,dwgt)
      return
      end

      subroutine dfill1(i,x,y,wgt)
      implicit none
      integer i
      real*8 x,y,wgt
      real*4 dx,dy,dwgt
      character*80 chtitl
      integer nx,ny,nwt,loc
      real*4 xmi,xma,ymi,yma
      call hgive(i,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
      dx=real(x)
      dy=real(y)
      dwgt=real(wgt)
c
c	handling of the end points.
c
      if(dx.eq.xma)dx=dx-(xma-xmi)/(10.*nx)
      if(ny.ne.0.and.dy.eq.yma)dy=dy-(yma-ymi)/(10.*ny)
c	call hfill(i,dx,dy,dwgt)
      call hf1(i,dx,dwgt)
      end

      subroutine setup_paw
c
c write a disk-file to be used with paw:
c
c        call hopera(2,'/',202,72,1.,1.)
c        call hopera(3,'/',203,73,1.,1.)
c        call hopera(4,'/',204,74,1.,1.)
c        call hopera(5,'/',205,75,1.,1.)
c
      call hrput(0,'pawplot.paw','N')
      return
      end
